/* atomic.h: These really suck for now.
 *
 * Copyright (C) 1996 David S. Miller (davem@caip.rutgers.edu)
 */

#ifndef __ARCH_SPARC_ATOMIC__
#define __ARCH_SPARC_ATOMIC__

typedef int atomic_t;

#ifdef __KERNEL__
#include <asm/system.h>
#include <asm/psr.h>

/*
 * Make sure gcc doesn't try to be clever and move things around
 * on us. We need to use _exactly_ the address the user gave us,
 * not some alias that contains the same information.
 */
#define __atomic_fool_gcc(x) ((struct { int a[100]; } *)x)

static __inline__ void atomic_add(atomic_t i, atomic_t *v)
{
	__asm__ __volatile__("
	rd	%%psr, %%g6
	or	%%g6, %2, %%g7
	wr	%%g7, 0x0, %%psr
	ld	[%0], %%g7
	add	%%g7, %1, %%g7
	st	%%g7, [%0]
	wr	%%g6, 0x0, %%psr
        nop; nop; nop;
        "
        : : "r" (__atomic_fool_gcc(v)), "r" (i), "i" (PSR_PIL)
        : "g6", "g7");
}

static __inline__ void atomic_sub(atomic_t i, atomic_t *v)
{
	__asm__ __volatile__("
	rd	%%psr, %%g6
	or	%%g6, %2, %%g7
	wr	%%g7, 0x0, %%psr
	ld	[%0], %%g7
	sub	%%g7, %1, %%g7
	st	%%g7, [%0]
	wr	%%g6, 0x0, %%psr
        nop; nop; nop;
        "
        : : "r" (__atomic_fool_gcc(v)), "r" (i), "i" (PSR_PIL)
        : "g6", "g7");
}

static __inline__ int atomic_sub_and_test(atomic_t i, atomic_t *v)
{
	__asm__ __volatile__("
	rd	%%psr, %%g6
	or	%%g6, %3, %%g7
	wr	%%g7, 0x0, %%psr
	ld	[%1], %%g7
	sub	%%g7, %2, %0
	st	%0, [%1]
	wr	%%g6, 0x0, %%psr
        nop; nop; nop;
        "
        : "=&r" (i)
        : "r" (__atomic_fool_gcc(v)), "0" (i), "i" (PSR_PIL)
        : "g6", "g7");

	return (i == 0);
}

static __inline__ void atomic_inc(atomic_t *v)
{
	__asm__ __volatile__("
	rd	%%psr, %%g6
	or	%%g6, %1, %%g7
	wr	%%g7, 0x0, %%psr
	ld	[%0], %%g7
	add	%%g7, 1, %%g7
	st	%%g7, [%0]
	wr	%%g6, 0x0, %%psr
        nop; nop; nop;
        "
        : : "r" (__atomic_fool_gcc(v)), "i" (PSR_PIL)
        : "g6", "g7");
}

static __inline__ void atomic_dec(atomic_t *v)
{
	__asm__ __volatile__("
	rd	%%psr, %%g6
	or	%%g6, %1, %%g7
	wr	%%g7, 0x0, %%psr
	ld	[%0], %%g7
	sub	%%g7, 1, %%g7
	st	%%g7, [%0]
	wr	%%g6, 0x0, %%psr
        nop; nop; nop;
        "
        : : "r" (__atomic_fool_gcc(v)), "i" (PSR_PIL)
        : "g6", "g7");
}

static __inline__ int atomic_dec_and_test(atomic_t *v)
{
	int i;

	__asm__ __volatile__("
	rd	%%psr, %%g6
	or	%%g6, %2, %%g7
	wr	%%g7, 0x0, %%psr
	ld	[%1], %%g7
	sub	%%g7, 1, %0
	st	%0, [%1]
	wr	%%g6, 0x0, %%psr
        nop; nop; nop;
        "
        : "=&r" (i)
        : "r" (__atomic_fool_gcc(v)), "i" (PSR_PIL)
        : "g6", "g7");

	return (i == 0);
}
#endif
#endif /* !(__ARCH_SPARC_ATOMIC__) */
